## ardour3 3.4~dfsg

=== wscript ===
#!/usr/bin/env python
from waflib.extras import autowaf as autowaf
from waflib import Options
import os
import re
import string
import subprocess
import sys

MAJOR = '3'
MINOR = '4'
VERSION = MAJOR + '.' + MINOR

APPNAME = 'Ardour' + MAJOR

# Mandatory variables
top = '.'
out = 'build'

children = [
        'libs/pbd',
        'libs/midi++2',
        'libs/evoral',
        'libs/vamp-sdk',
        'libs/qm-dsp',
        'libs/vamp-plugins',
        'libs/taglib',
        'libs/libltc',
        'libs/rubberband',
        'libs/surfaces',
        'libs/panners',
        'libs/timecode',
        'libs/ardour',
        'libs/gtkmm2ext',
        'libs/clearlooks-newer',
        'libs/audiographer',
        'gtk2_ardour',
        'export',
        'midi_maps',
        'mcp',
        'patchfiles'
]

i18n_children = [
        'gtk2_ardour',
        'libs/ardour',
        'libs/gtkmm2ext',
]

if sys.platform == 'linux2':
    children += [ 'tools/sanity_check' ]
    lxvst_default = True
elif sys.platform == 'darwin':
    children += [ 'libs/appleutility' ]
    lxvst_default = False
else:
    lxvst_default = False

# Version stuff

def fetch_gcc_version (CC):
    cmd = "LANG= %s --version" % CC
    output = subprocess.Popen(cmd, shell=True, stderr=subprocess.STDOUT, stdout=subprocess.PIPE).communicate()[0].splitlines()
    o = output[0].decode('utf-8')
    version = o.split(' ')[2].split('.')
    return version

def fetch_git_revision ():
    cmd = "LANG= git describe --tags HEAD"
    output = subprocess.Popen(cmd, shell=True, stderr=subprocess.STDOUT, stdout=subprocess.PIPE).communicate()[0].splitlines()
    rev = output[0].decode('utf-8')
    return rev

def create_stored_revision():
    rev = ""
    if os.path.exists('.git'):
        rev = fetch_git_revision();
        print("ardour.git version: " + rev + "\n")
    elif os.path.exists('libs/ardour/revision.cc'):
        print("Using packaged revision")
        return
    else:
        print("Missing libs/ardour/revision.cc.  Blame the packager.")
        sys.exit(-1)

    try:
        text =  '#include "ardour/revision.h"\n'
        text += 'namespace ARDOUR { const char* revision = \"%s\"; }\n' % rev
        print('Writing revision info to libs/ardour/revision.cc using ' + rev)
        o = open('libs/ardour/revision.cc', 'w')
        o.write(text)
        o.close()
    except IOError:
        print('Could not open libs/ardour/revision.cc for writing\n')
        sys.exit(-1)

def set_compiler_flags (conf,opt):
    #
    # Compiler flags and other system-dependent stuff
    #

    build_host_supports_sse = False
    optimization_flags = []
    debug_flags = []

    u = os.uname ()
    cpu = u[4]
    platform = u[0].lower()
    version = u[2]

    # waf adds -O0 -g itself. thanks waf!
    is_clang = conf.env['CXX'][0].endswith('clang++')
    
    if conf.options.cxx11:
        conf.check_cxx(cxxflags=["-std=c++11"])
        conf.env.append_unique('CXXFLAGS', ['-std=c++11'])
        if platform == "darwin":
            conf.env.append_unique('CXXFLAGS', ['-stdlib=libc++'])
            conf.env.append_unique('LINKFLAGS', ['-lc++'])
            # Prevents visibility issues in standard headers
            conf.define("_DARWIN_C_SOURCE", 1)

    if is_clang and platform == "darwin":
        # Silence warnings about the non-existing osx clang compiler flags
        # -compatibility_version and -current_version.  These are Waf
        # generated and not needed with clang
        conf.env.append_unique ("CXXFLAGS", ["-Qunused-arguments"])
        
    if opt.gprofile:
        debug_flags = [ '-pg' ]

    if opt.backtrace:
        if platform != 'darwin' and not is_clang:
            debug_flags = [ '-rdynamic' ]

    # Autodetect
    if opt.dist_target == 'auto':
        if platform == 'darwin':
            # The [.] matches to the dot after the major version, "." would match any character
            if re.search ("^[0-7][.]", version) != None:
                conf.env['build_target'] = 'panther'
            elif re.search ("^8[.]", version) != None:
                conf.env['build_target'] = 'tiger'
            elif re.search ("^9[.]", version) != None:
                conf.env['build_target'] = 'leopard'
            elif re.search ("^10[.]", version) != None:
                conf.env['build_target'] = 'snowleopard'
            elif re.search ("^11[.]", version) != None:
                conf.env['build_target'] = 'lion'
            else:
                conf.env['build_target'] = 'mountainlion'
        else:
            if re.search ("x86_64", cpu) != None:
                conf.env['build_target'] = 'x86_64'
            elif re.search("i[0-5]86", cpu) != None:
                conf.env['build_target'] = 'i386'
            elif re.search("powerpc", cpu) != None:
                conf.env['build_target'] = 'powerpc'
            else:
                conf.env['build_target'] = 'i686'
    else:
        conf.env['build_target'] = opt.dist_target

    if conf.env['build_target'] == 'snowleopard':
        #
        # stupid OS X 10.6 has a bug in math.h that prevents llrint and friends
        # from being visible.
        # 
        debug_flags.append ('-U__STRICT_ANSI__')
        optimization_flags.append ('-U__STRICT_ANSI__')

    if cpu == 'powerpc' and conf.env['build_target'] != 'none':
        #
        # Apple/PowerPC optimization options
        #
        # -mcpu=7450 does not reliably work with gcc 3.*
        #
        if opt.dist_target == 'panther' or opt.dist_target == 'tiger':
            if platform == 'darwin':
                # optimization_flags.extend ([ "-mcpu=7450", "-faltivec"])
                # to support g3s but still have some optimization for above
                optimization_flags.extend ([ "-mcpu=G3", "-mtune=7450"])
            else:
                optimization_flags.extend ([ "-mcpu=7400", "-maltivec", "-mabi=altivec"])
        else:
            optimization_flags.extend([ "-mcpu=750", "-mmultiple" ])
        optimization_flags.extend (["-mhard-float", "-mpowerpc-gfxopt"])
        optimization_flags.extend (["-Os"])

    elif ((re.search ("i[0-9]86", cpu) != None) or (re.search ("x86_64", cpu) != None)) and conf.env['build_target'] != 'none':


        #
        # ARCH_X86 means anything in the x86 family from i386 to x86_64
        # the compile-time presence of the macro _LP64 is used to 
        # distingush 32 and 64 bit assembler
        #

        if (re.search ("(i[0-9]86|x86_64)", cpu) != None):
            debug_flags.append ("-DARCH_X86")
            optimization_flags.append ("-DARCH_X86")

        if platform == 'linux' :

            #
            # determine processor flags via /proc/cpuinfo
            #

            if conf.env['build_target'] != 'i386':

                flag_line = os.popen ("cat /proc/cpuinfo | grep '^flags'").read()[:-1]
                x86_flags = flag_line.split (": ")[1:][0].split ()

                if "mmx" in x86_flags:
                    optimization_flags.append ("-mmmx")
                if "sse" in x86_flags:
                    build_host_supports_sse = True
                if "3dnow" in x86_flags:
                    optimization_flags.append ("-m3dnow")

            if cpu == "i586":
                optimization_flags.append ("-march=i586")
            elif cpu == "i686":
                optimization_flags.append ("-march=i686")

        if not is_clang and ((conf.env['build_target'] == 'i686') or (conf.env['build_target'] == 'x86_64')) and build_host_supports_sse:
            optimization_flags.extend (["-msse", "-mfpmath=sse", "-DUSE_XMMINTRIN"])
            debug_flags.extend (["-msse", "-mfpmath=sse", "-DUSE_XMMINTRIN"])

    # end of processor-specific section

    # optimization section
    if conf.env['FPU_OPTIMIZATION']:
        if sys.platform == 'darwin':
            optimization_flags.append ("-DBUILD_VECLIB_OPTIMIZATIONS");
            debug_flags.append ("-DBUILD_VECLIB_OPTIMIZATIONS");
            conf.env.append_value('LINKFLAGS', "-framework Accelerate")
        elif conf.env['build_target'] == 'i686' or conf.env['build_target'] == 'x86_64':
            optimization_flags.append ("-DBUILD_SSE_OPTIMIZATIONS")
            debug_flags.append ("-DBUILD_SSE_OPTIMIZATIONS")
        if not build_host_supports_sse:
            print("\nWarning: you are building Ardour with SSE support even though your system does not support these instructions. (This may not be an error, especially if you are a package maintainer)")

    # end optimization section

    #
    # no VST on x86_64
    #

    if conf.env['build_target'] == 'x86_64' and opt.windows_vst:
        print("\n\n==================================================")
        print("You cannot use VST plugins with a 64 bit host. Please run waf with --windows-vst=0")
        print("\nIt is theoretically possible to build a 32 bit host on a 64 bit system.")
        print("However, this is tricky and not recommended for beginners.")
        sys.exit (-1)

    if opt.lxvst:
        if conf.env['build_target'] == 'x86_64':
            conf.env.append_value('CXXFLAGS', "-DLXVST_64BIT")
        else:
            conf.env.append_value('CXXFLAGS', "-DLXVST_32BIT")

    #
    # a single way to test if we're on OS X
    #

    if conf.env['build_target'] in ['panther', 'tiger', 'leopard', 'snowleopard' ]:
        conf.define ('IS_OSX', 1)
        # force tiger or later, to avoid issues on PPC which defaults
        # back to 10.1 if we don't tell it otherwise.
        
        conf.env.append_value('CFLAGS', "-DMAC_OS_X_VERSION_MIN_REQUIRED=1040")
        conf.env.append_value('CXXFLAGS', "-DMAC_OS_X_VERSION_MIN_REQUIRED=1040")
        conf.env.append_value('CXXFLAGS', '-mmacosx-version-min=10.4')
        conf.env.append_value('CFLAGS', '-mmacosx-version-min=10.4')


    elif conf.env['build_target'] in [ 'lion', 'mountainlion' ]:
        conf.env.append_value('CFLAGS', "-DMAC_OS_X_VERSION_MIN_REQUIRED=1070")
        conf.env.append_value('CXXFLAGS', "-DMAC_OS_X_VERSION_MIN_REQUIRED=1070")
        conf.env.append_value('CXXFLAGS', '-mmacosx-version-min=10.7')
        conf.env.append_value('CFLAGS', '-mmacosx-version-min=10.7')
    else:
        conf.define ('IS_OSX', 0)

    #
    # save off CPU element in an env
    #
    conf.define ('CONFIG_ARCH', cpu)

    #
    # ARCH="..." overrides all
    #

    if opt.arch != None:
        optimization_flags = opt.arch.split()

    #
    # prepend boiler plate optimization flags that work on all architectures
    #

    optimization_flags[:0] = [
            "-O3",
            "-fomit-frame-pointer",
            "-ffast-math",
            "-fstrength-reduce",
            "-pipe"
            ]

    if opt.debug:
        conf.env.append_value('CFLAGS', debug_flags)
        conf.env.append_value('CXXFLAGS', debug_flags)
        conf.env.append_value('LINKFLAGS', debug_flags)
    else:
        conf.env.append_value('CFLAGS', optimization_flags)
        conf.env.append_value('CXXFLAGS', optimization_flags)
        conf.env.append_value('LINKFLAGS', optimization_flags)

    if opt.stl_debug:
        conf.env.append_value('CXXFLAGS', "-D_GLIBCXX_DEBUG")

    if conf.env['DEBUG_RT_ALLOC']:
        conf.env.append_value('CFLAGS', '-DDEBUG_RT_ALLOC')
        conf.env.append_value('CXXFLAGS', '-DDEBUG_RT_ALLOC')
        conf.env.append_value('LINKFLAGS', '-ldl')

    if conf.env['DEBUG_DENORMAL_EXCEPTION']:
        conf.env.append_value('CFLAGS', '-DDEBUG_DENORMAL_EXCEPTION')
        conf.env.append_value('CXXFLAGS', '-DDEBUG_DENORMAL_EXCEPTION')

    if opt.universal:
        if opt.generic:
            print ('Specifying Universal and Generic builds at the same time is not supported')
            sys.exit (1)
        else:
            if not Options.options.nocarbon:
                conf.env.append_value('CFLAGS', ["-arch", "i386", "-arch", "ppc"])
                conf.env.append_value('CXXFLAGS', ["-arch", "i386", "-arch", "ppc"])

=== gtk2_ardour/wscript ===
#!/usr/bin/env python
from waflib.extras import autowaf as autowaf
from waflib import Options, TaskGen
import waflib.Logs as Logs, waflib.Utils as Utils
import os
import sys
import re
import time
from waflib.Task import Task

I18N_PACKAGE = 'gtk2_ardour3'

# Mandatory variables
top = '.'
out = 'build'

path_prefix = 'gtk2_ardour/'

gtk2_ardour_sources = [
        'about.cc',
        'actions.cc',
        'add_route_dialog.cc',
        'ambiguous_file_dialog.cc',
        'analysis_window.cc',
        'ardour_button.cc',
        'ardour_dialog.cc',
        'ardour_ui.cc',
        'ardour_ui2.cc',
        'ardour_ui_dependents.cc',
        'ardour_ui_dialogs.cc',
        'ardour_ui_ed.cc',
        'ardour_ui_mixer.cc',
        'ardour_ui_options.cc',
        'ardour_window.cc',
        'audio_clock.cc',
        'audio_region_editor.cc',
        'audio_region_view.cc',
        'audio_streamview.cc',
        'audio_time_axis.cc',
        'automation_controller.cc',
        'automation_line.cc',
        'automation_region_view.cc',
        'automation_streamview.cc',
        'automation_time_axis.cc',
        'axis_view.cc',
        'big_clock_window.cc',
        'bundle_manager.cc',
        'button_joiner.cc',
        'canvas-flag.cc',
        'canvas-hit.cc',
        'canvas-note-event.cc',
        'canvas-note.cc',
        'canvas_patch_change.cc',
        'canvas-simpleline.c',
        'canvas-simplerect.c',
        'canvas-sysex.cc',
        'canvas-waveview.c',
        'clock_group.cc',
        'configinfo.cc',
        'control_point.cc',
        'control_point_dialog.cc',
        'curvetest.cc',
        'debug.cc',
        'diamond.cc',
        'edit_note_dialog.cc',
        'editing.cc',
        'editor.cc',
        'editor_actions.cc',
        'editor_audio_import.cc',
        'editor_audiotrack.cc',
        'editor_canvas.cc',
        'editor_canvas_events.cc',
        'editor_component.cc',
        'editor_cursors.cc',
        'editor_drag.cc',
        'editor_route_groups.cc',
        'editor_export_audio.cc',
        'editor_group_tabs.cc',
        'editor_keys.cc',
        'editor_locations.cc',
        'editor_markers.cc',
        'editor_mixer.cc',
        'editor_mouse.cc',
        'editor_ops.cc',
        'editor_regions.cc',
        'editor_routes.cc',
        'editor_rulers.cc',
        'editor_selection.cc',
        'editor_snapshots.cc',
        'editor_summary.cc',
        'editor_tempodisplay.cc',
        'editor_timefx.cc',
        'engine_dialog.cc',
        'enums.cc',
        'export_channel_selector.cc',
        'export_dialog.cc',
        'export_file_notebook.cc',
        'export_filename_selector.cc',
        'export_format_dialog.cc',
        'export_format_selector.cc',
        'export_preset_selector.cc',
        'export_timespan_selector.cc',
        'fft.cc',
        'fft_graph.cc',
        'fft_result.cc',
        'sfdb_freesound_mootcher.cc',
        'gain_meter.cc',
        'generic_pluginui.cc',
        'ghostregion.cc',
        'global_port_matrix.cc',
        'group_tabs.cc',
        'gtk-custom-hruler.c',
        'gtk-custom-ruler.c',
        'gtk_pianokeyboard.c',
        'gui_object.cc',
        'insert_time_dialog.cc',
        'interthread_progress_window.cc',
        'io_selector.cc',
        'keyboard.cc',
        'keyeditor.cc',
        'latency_gui.cc',
        'led.cc',
        'level_meter.cc',
        'lineset.cc',
        'location_ui.cc',
        'main.cc',
        'main_clock.cc',
        'marker.cc',
        'midi_automation_line.cc',
        'midi_channel_dialog.cc',
        'midi_channel_selector.cc',
        'midi_cut_buffer.cc',
        'midi_export_dialog.cc',
        'midi_list_editor.cc',
        'midi_port_dialog.cc',
        'midi_region_view.cc',
        'midi_scroomer.cc',
        'midi_selection.cc',
        'midi_streamview.cc',
        'midi_time_axis.cc',
        'midi_tracer.cc',
        'midi_velocity_dialog.cc',
        'missing_file_dialog.cc',
        'missing_plugin_dialog.cc',
        'mixer_actor.cc',
        'mixer_group_tabs.cc',
        'mixer_strip.cc',
        'mixer_ui.cc',
        'meterbridge.cc',
        'meter_strip.cc',
        'meter_patterns.cc',
        'monitor_section.cc',
        'mono_panner.cc',
        'mono_panner_editor.cc',
        'mouse_cursors.cc',
        'nag.cc',
        'new_plugin_preset_dialog.cc',
        'normalize_dialog.cc',
        'note_player.cc',
        'nsm.cc',
        'nsmclient.cc',
        'option_editor.cc',
        'opts.cc',
        'panner2d.cc',
        'panner_editor.cc',
        'panner_interface.cc',
        'panner_ui.cc',
        'piano_roll_header.cc',
        'pingback.cc',
        'playlist_selector.cc',
        'plugin_eq_gui.cc',
        'plugin_selector.cc',
        'plugin_ui.cc',
        'port_group.cc',
        'port_insert_ui.cc',
        'port_matrix.cc',
        'port_matrix_body.cc',
        'port_matrix_column_labels.cc',
        'port_matrix_component.cc',
        'port_matrix_grid.cc',
        'port_matrix_labels.cc',
        'port_matrix_row_labels.cc',
        'processor_box.cc',
        'patch_change_dialog.cc',
        'progress_reporter.cc',
        'prompter.cc',
        'public_editor.cc',
        'quantize_dialog.cc',
        'rc_option_editor.cc',
        'region_editor.cc',
        'region_gain_line.cc',
        'region_layering_order_editor.cc',
        'region_selection.cc',
        'region_view.cc',
        'return_ui.cc',
        'rhythm_ferret.cc',
        'route_group_dialog.cc',
        'route_group_menu.cc',
        'route_params_ui.cc',
        'route_processor_selection.cc',
        'route_time_axis.cc',
        'route_ui.cc',
        'search_path_option.cc',
        'selection.cc',
        'send_ui.cc',
        'session_import_dialog.cc',
        'session_metadata_dialog.cc',
        'session_option_editor.cc',
        'sfdb_ui.cc',
        'shuttle_control.cc',
        'simpleline.cc',
        'simplerect.cc',
        'splash.cc',
        'speaker_dialog.cc',
        'startup.cc',
        'step_editor.cc',
        'step_entry.cc',
        'stereo_panner.cc',
        'stereo_panner_editor.cc',
        'streamview.cc',
        'strip_silence_dialog.cc',
        'tape_region_view.cc',
        'tempo_dialog.cc',
        'tempo_lines.cc',
        'theme_manager.cc',
        'time_axis_view.cc',
        'time_axis_view_item.cc',
        'time_fx_dialog.cc',
        'time_info_box.cc',
        'time_selection.cc',
        'track_selection.cc',
        'track_view_list.cc',
        'transpose_dialog.cc',
        'ui_config.cc',
        'utils.cc',
        'verbose_cursor.cc',
        'version.cc',
        'visibility_group.cc',
        'volume_controller.cc',
        'waveview.cc',
        'window_manager.cc',
# video-timeline related sources:
        'video_image_frame.cc',
        'add_video_dialog.cc',
        'editor_videotimeline.cc',
        'video_timeline.cc',
        'system_exec.cc',
        'video_monitor.cc',
        'transcode_ffmpeg.cc',
        'transcode_video_dialog.cc',
        'video_server_dialog.cc',
        'utils_videotl.cc',
        'export_video_dialog.cc',
        'export_video_infobox.cc'
]

def options(opt):
    autowaf.set_options(opt)

def configure(conf):
    conf.load('misc')
    conf.load('compiler_cxx')
    # we don't use hard-coded micro versions with ardour, so hard code it to zero
    autowaf.build_version_files(
        path_prefix + 'version.h',
        path_prefix + 'version.cc',
        'gtk2_ardour', conf.env['MAJOR'], conf.env['MINOR'], 0)
    autowaf.configure(conf)

    if re.search ("linux", sys.platform) != None:
        autowaf.check_pkg(conf, 'alsa', uselib_store='ALSA')

    # TODO: Insert a sanity check for on OS X to ensure CoreAudio is present

    autowaf.check_pkg(conf, 'flac', uselib_store='FLAC',
                      atleast_version='1.2.1')
    autowaf.check_pkg(conf, 'gthread-2.0', uselib_store='GTHREAD',
                      atleast_version='2.10.1')
    autowaf.check_pkg(conf, 'gtk+-2.0', uselib_store='GTK',
                      atleast_version='2.18')
    autowaf.check_pkg(conf, 'gtkmm-2.4', uselib_store='GTKMM',
                      atleast_version='2.18')
    autowaf.check_pkg(conf, 'libgnomecanvas-2.0',
                      uselib_store='GNOMECANVAS', atleast_version='2.30')
    autowaf.check_pkg(conf, 'libgnomecanvasmm-2.6',
                      uselib_store='GNOMECANVASMM', atleast_version='2.16')
    autowaf.check_pkg(conf, 'ogg', uselib_store='OGG', atleast_version='1.1.2')
    autowaf.check_pkg(conf, 'x11', uselib_store='X11', atleast_version='1.1', mandatory=False)
    autowaf.check_pkg(conf, 'fontconfig', uselib_store='FONTCONFIG')

    conf.write_config_header('gtk2ardour-config.h', remove=False)

    # Boost headers
    autowaf.check_header(conf, 'cxx', 'boost/shared_ptr.hpp')
    autowaf.check_header(conf, 'cxx', 'boost/weak_ptr.hpp')

# Add a waf `feature' to allow compilation of things using winegcc
from waflib.TaskGen import feature
@feature("wine")
def set_winegcc(self):
    self.env.LINK_CXX = self.env.LINK_CC = 'wineg++'
    self.env.CC = 'winegcc'

def _doPyp(infileName, deps = False):
    outStr = ''
    out = []
    re_spaces = re.compile("\s+")

    if infileName == '-':
        fd = sys.stdin
    else:
        fd = open(infileName)
    inLines = fd.readlines()
    if fd != sys.stdin:
        fd.close()
        

    for line in inLines:
        bits = re_spaces.split(line)
        if bits[0] == '##include':
            incName = bits[1]
            if (deps):
                out += [ incName ]
            else:
                # assume included file comes from same place as source file
                incName = os.path.join (os.path.dirname (infileName), incName);
                outStr += _doPyp(incName)
        else:
            if not deps:
                outStr += line

    # done
    if deps:
        return out
    else:
        return outStr

def include_processor(task):
    infileName = task.inputs[0].srcpath()
    outfileName = os.path.join(out, task.outputs[0].bldpath())
    fdOut = open (outfileName, "w")
    fdOut.write (_doPyp(infileName))
    fdOut.close ()


def build_color_scheme(path, prefix):
    f = open (path, 'r')
    color_scheme = ''
    for line in f:
        if re.search ('^#@color', line):
            line.strip() # remove newline
            words = line.split()
            if len(color_scheme):
                color_scheme += ';'
            color_scheme += prefix
            color_scheme += '_'
            color_scheme += words[1]
            color_scheme += ':'
            color_scheme += words[2]
    f.close()
    return color_scheme

def build(bld):

    VERSION = "%s.%s" % (bld.env['MAJOR'], bld.env['MINOR'])

    if bld.is_defined('WINDOWS_VST_SUPPORT'):
        # If we require VST support we build a stub main() and the FST library
        # here using winegcc, and link it to the GTK front-end library
        obj = bld(features = 'cxx c cxxprogram wine')
        obj.source = '''
                ../libs/fst/fst.c
                ../libs/fst/fstinfofile.c
                ../libs/fst/vsti.c
                ../libs/fst/vstwin.c
                ../vst/winmain.c
        '''
        obj.uselib = 'ALSA'
        obj.use          = [ 'libpbd',
                             'libmidipp',
                             'libtaglib',
                             'libardour',
                             'libardour_cp',
                             'libgtk2_ardour',
                             'libgtkmm2ext',
                             'libtaglib']
        obj.target = 'ardour-' + bld.env['VERSION'] + '-vst.exe.so'
        obj.includes  = [ '../libs/fst', '.' ]
        obj.linkflags = ['-mwindows', '-Wl,--export-dynamic']
        obj.defines = ['_POSIX_SOURCE', 'USE_WS_PREFIX']
        obj.install_path = os.path.join(bld.env['LIBDIR'], 'ardour3')
        # end of the wine executable

=== libs/ardour/wscript ===
#!/usr/bin/env python
from waflib.extras import autowaf as autowaf
from waflib import Options
import os
import re
import subprocess

# default state file version for this build
CURRENT_SESSION_FILE_VERSION = 3001

# Variables for 'waf dist'
APPNAME = 'libardour3'
I18N_PACKAGE = 'ardour3'

# Mandatory variables
top = '.'
out = 'build'

path_prefix = 'libs/ardour/'

libardour_sources = [
        'amp.cc',
        'analyser.cc',
        'audio_buffer.cc',
        'audio_diskstream.cc',
        'audio_library.cc',
        'audio_playlist.cc',
        'audio_playlist_importer.cc',
        'audio_playlist_source.cc',
        'audio_port.cc',
        'audio_region_importer.cc',
        'audio_track.cc',
        'audio_track_importer.cc',
        'audioanalyser.cc',
        'audioengine.cc',
        'audiofile_tagger.cc',
        'audiofilesource.cc',
        'audioregion.cc',
        'audiosource.cc',
        'auditioner.cc',
        'automatable.cc',
        'automation.cc',
        'automation_control.cc',
        'automation_list.cc',
        'automation_watch.cc',
        'beats_frames_converter.cc',
        'broadcast_info.cc',
        'buffer.cc',
        'buffer_manager.cc',
        'buffer_set.cc',
        'bundle.cc',
        'butler.cc',
        'capturing_processor.cc',
        'chan_count.cc',
        'chan_mapping.cc',
        'configuration.cc',
        'config_text.cc',
        'control_protocol_manager.cc',
        'control_protocol_search_path.cc',
        'cycle_timer.cc',
        'data_type.cc',
        'default_click.cc',
        'debug.cc',
        'delivery.cc',
        'directory_names.cc',
        'diskstream.cc',
        'element_import_handler.cc',
        'element_importer.cc',
        'enums.cc',
        'event_type_map.cc',
        'export_channel.cc',
        'export_channel_configuration.cc',
        'export_failed.cc',
        'export_filename.cc',
        'export_format_base.cc',
        'export_format_manager.cc',
        'export_format_specification.cc',
        'export_formats.cc',
        'export_formats_search_path.cc',
        'export_graph_builder.cc',
        'export_handler.cc',
        'export_preset.cc',
        'export_profile_manager.cc',
        'export_status.cc',
        'export_timespan.cc',
        'file_source.cc',
        'filename_extensions.cc',
        'filesystem_paths.cc',
        'filter.cc',
        'find_session.cc',
        'globals.cc',
        'graph.cc',
        'graphnode.cc',
        'iec1ppmdsp.cc',
        'iec2ppmdsp.cc',
        'import.cc',
        'instrument_info.cc',
        'internal_return.cc',
        'internal_send.cc',
        'interpolation.cc',
        'io.cc',
        'io_processor.cc',
        'jack_slave.cc',
        'kmeterdsp.cc',
        'ladspa_plugin.cc',
        'location.cc',
        'location_importer.cc',
        'ltc_slave.cc',
        'lv2_bundled_search_path.cc',
        'meter.cc',
        'midi_automation_list_binder.cc',
        'midi_buffer.cc',
        'midi_clock_slave.cc',
        'midi_diskstream.cc',
        'midi_model.cc',
        'midi_patch_manager.cc',
        'midi_patch_search_path.cc',
        'midi_playlist.cc',
        'midi_playlist_source.cc',
        'midi_port.cc',
        'midi_region.cc',
        'midi_ring_buffer.cc',
        'midi_source.cc',
        'midi_state_tracker.cc',
        'midi_stretch.cc',
        'midi_track.cc',
        'midi_ui.cc',
        'mix.cc',
        'monitor_processor.cc',
        'mtc_slave.cc',
        'mtdm.cc',
        'mute_master.cc',
        'onset_detector.cc',
        'operations.cc',
        'pan_controllable.cc',
        'pannable.cc',
        'panner.cc',
        'panner_manager.cc',
        'panner_search_path.cc',
        'panner_shell.cc',
        'pcm_utils.cc',
        'pi_controller.cc',
        'playlist.cc',
        'playlist_factory.cc',
        'playlist_source.cc',
        'plugin.cc',
        'plugin_insert.cc',
        'plugin_manager.cc',
        'port.cc',
        'port_insert.cc',
        'port_set.cc',
        'process_thread.cc',
        'processor.cc',
        'progress.cc',
        'quantize.cc',
        'rc_configuration.cc',
        'recent_sessions.cc',
        'region_factory.cc',
        'resampled_source.cc',
        'region.cc',
        'return.cc',
        'reverse.cc',
        'route.cc',
        'route_graph.cc',
        'route_group.cc',
        'route_group_member.cc',
        'rb_effect.cc',
        'send.cc',
        'session.cc',
        'session_butler.cc',
        'session_click.cc',
        'session_command.cc',
        'session_configuration.cc',
        'session_directory.cc',
        'session_events.cc',
        'session_export.cc',
        'session_handle.cc',
        'session_ltc.cc',
        'session_metadata.cc',
        'session_midi.cc',
        'session_object.cc',
        'session_playlists.cc',
        'session_process.cc',
        'session_rtevents.cc',
        'session_state.cc',
        'session_state_utils.cc',
        'session_time.cc',
        'session_transport.cc',
        'slave.cc',
        'smf_source.cc',
        'sndfile_helpers.cc',
        'sndfileimportable.cc',
        'sndfilesource.cc',
        'source.cc',
        'source_factory.cc',
        'speakers.cc',
        'strip_silence.cc',
        'revision.cc',
        'tape_file_matcher.cc',
        'template_utils.cc',
        'tempo.cc',
        'tempo_map_importer.cc',
        'thread_buffers.cc',
        'ticker.cc',
        'track.cc',
        'transient_detector.cc',
        'unknown_processor.cc',
        'user_bundle.cc',
        'utils.cc',
        'version.cc',
        'vumeterdsp.cc',
        'worker.cc'
]

def flac_supported():
    cmd = subprocess.Popen ("sndfile-info testfile.flac",
                            stdout = subprocess.PIPE,
                            stderr = subprocess.STDOUT, shell = True)
    out = cmd.communicate()[0].decode('utf-8');
    return re.search ('unknown format', out) == None

def ogg_supported():
    cmd = subprocess.Popen ("sndfile-info testfile.ogg",
                            stdout = subprocess.PIPE,
                            stderr = subprocess.STDOUT, shell = True)
    out = cmd.communicate()[0].decode('utf-8');
    return re.search ('unknown format', out) == None

def options(opt):
    autowaf.set_options(opt)

def configure(conf):
    conf.load('compiler_cxx')
    conf.load('gas')
    # we don't use hard-coded micro versions with ardour, so hard code it to zero
    autowaf.build_version_files(
        path_prefix + 'ardour/version.h',
        path_prefix + 'version.cc',
        'libardour3', conf.env['MAJOR'], conf.env['MINOR'], 0)
    autowaf.configure(conf)
    autowaf.check_pkg(conf, 'aubio', uselib_store='AUBIO',
                      atleast_version='0.3.2')
    autowaf.check_pkg(conf, 'jack', uselib_store='JACK',
                      atleast_version='0.118.2')
    autowaf.check_pkg(conf, 'libxml-2.0', uselib_store='XML')
    autowaf.check_pkg(conf, 'lrdf', uselib_store='LRDF',
                      atleast_version='0.4.0')
    autowaf.check_pkg(conf, 'samplerate', uselib_store='SAMPLERATE',
                      atleast_version='0.1.0')
    autowaf.check_pkg(conf, 'sigc++-2.0', uselib_store='SIGCPP',
                      atleast_version='2.0')
    if Options.options.lv2:
        autowaf.check_pkg(conf, 'lv2', uselib_store='LV2',
                          atleast_version='1.0.0', mandatory=True)
        autowaf.check_pkg(conf, 'lv2', uselib_store='NEW_LV2',
                          atleast_version='1.0.15', mandatory=False)
        autowaf.check_pkg(conf, 'serd-0', uselib_store='SERD',
                          atleast_version='0.14.0', mandatory=True)
        autowaf.check_pkg(conf, 'sord-0', uselib_store='SORD',
                          atleast_version='0.8.0', mandatory=True)
        autowaf.check_pkg(conf, 'sratom-0', uselib_store='SRATOM',
                          atleast_version='0.2.0', mandatory=True)
        autowaf.check_pkg(conf, 'lilv-0', uselib_store='LILV',
                          atleast_version='0.14.0', mandatory=True)
        autowaf.check_pkg(conf, 'lilv-0', uselib_store='NEW_LILV',
                          atleast_version='0.15.0', mandatory=False)
        autowaf.check_pkg(conf, 'suil-0', uselib_store='SUIL',
                          atleast_version='0.6.0', mandatory=False)
        conf.define ('LV2_SUPPORT', 1)

#    autowaf.check_pkg(conf, 'soundtouch-1.0', uselib_store='SOUNDTOUCH',
#                      mandatory=False)
    autowaf.check_pkg(conf, 'cppunit', uselib_store='CPPUNIT',
                      atleast_version='1.12.0', mandatory=False)
    autowaf.check_pkg(conf, 'ogg', uselib_store='OGG', atleast_version='1.1.2')
    autowaf.check_pkg(conf, 'flac', uselib_store='FLAC',
                      atleast_version='1.2.1')
    autowaf.check_pkg(conf, 'libcurl', uselib_store='CURL',
                      atleast_version='7.0.0')

    # we don't try to detect this, since its part of our source tree

    conf.define('HAVE_RUBBERBAND', 1) # controls whether we think we have it
    conf.define('USE_RUBBERBAND', 1)  # controls whether we actually use it

    conf.define('CURRENT_SESSION_FILE_VERSION', CURRENT_SESSION_FILE_VERSION)

    conf.check(header_name='sys/vfs.h', define_name='HAVE_SYS_VFS_H',mandatory=False)
    conf.check(header_name='sys/statvfs.h', define_name='HAVE_SYS_STATVFS_H',mandatory=False)

    conf.check(header_name='jack/session.h', uselib = [ 'JACK' ],
               define_name='HAVE_JACK_SESSION')

    conf.check(header_name='unistd.h', define_name='HAVE_UNISTD',mandatory=False)

    conf.check_cc(fragment = '''
#include <jack/jack.h>
void callback(jack_status_t code, const char* reason, void* arg) { return; }
int main(int argc, char **argv) {
    jack_client_t* c;
    jack_on_info_shutdown(c, callback, (void*) 0);
    return 0;
}''',
                  uselib= [ 'JACK' ],
                  msg = 'Checking for jack_on_info_shutdown',
                  define_name = 'HAVE_JACK_ON_INFO_SHUTDOWN',
                  okmsg = 'present')

    missing_jack_message = 'missing - a version of JACK that supports jack_port_set_latency_range() is required to compile Ardour3.'

    conf.check_cc(fragment = '''
#include <jack/jack.h>
int main(int argc, char **argv) {
    jack_port_t* p;
    jack_latency_range_t r;
    jack_port_set_latency_range(p, JackCaptureLatency, &r);
    return 0;
}''',
                  uselib = [ 'JACK' ],
                  msg = 'Checking for new JACK latency API',
                  okmsg = 'present',
                  mandatory = True,
                  errmsg = missing_jack_message)

    conf.check_cc(fragment = '''
#include <jack/jack.h>
int main(int argc, char **argv) {
   jack_port_type_get_buffer_size((jack_client_t*)0, "");
   return 0;
}''',
                  uselib = [ 'JACK' ],
                  msg = 'Checking for new jack_port_type_get_buffer_size',
                  okmsg = 'present',
                  mandatory = True,
                  errmsg = missing_jack_message)

    conf.check_cc(fragment = '''
#include <jack/transport.h>
int main(int argc, char** argv) {
  jack_position_t pos;
  pos.valid & JackVideoFrameOffset;
  return 0;
}''',
                  uselib= [ 'JACK' ],
                  msg = 'Checking for JackVideoFrameOffset',
                  define_name = 'HAVE_JACK_VIDEO_SUPPORT',
                  mandatory = False,
                  okmsg = 'present')

    if flac_supported():
        conf.define ('HAVE_FLAC', 1)
    if ogg_supported():
        conf.define ('HAVE_OGG', 1)

    conf.write_config_header('libardour-config.h', remove=False)

    # Boost headers
    autowaf.check_header(conf, 'cxx', 'boost/shared_ptr.hpp')
    autowaf.check_header(conf, 'cxx', 'boost/weak_ptr.hpp')
    autowaf.check_header(conf, 'cxx', 'boost/scoped_ptr.hpp')
    autowaf.check_header(conf, 'cxx', 'boost/ptr_container/ptr_list.hpp')


def build(bld):

=== libs/libltc/wscript ===
#!/usr/bin/env python
from waflib.extras import autowaf as autowaf
from waflib import TaskGen
import os
import sys

# Version of this package (even if built as a child)
MAJOR = '1'
MINOR = '1'
MICRO = '1'
LIBLTC_VERSION = "%s.%s.%s" % (MAJOR, MINOR, MICRO)

# Library version (UNIX style major, minor, micro)
# major increment <=> incompatible changes
# minor increment <=> compatible changes (additions)
# micro increment <=> no interface changes
LIBLTC_LIB_VERSION = '1.1.1'

# Variables for 'waf dist'
APPNAME = 'libltc'
VERSION = LIBLTC_VERSION
I18N_PACKAGE = 'libltc'

# Mandatory variables
top = '.'
out = 'build'

def options(opt):
    autowaf.set_options(opt)

def configure(conf):
    conf.load('compiler_c')
    autowaf.configure(conf)

def build(bld):
    obj = bld(features = 'c cshlib')
    obj.source = '''
              ltc.c
              timecode.c
              encoder.c
              decoder.c
    '''

    obj.export_includes = ['.']
    obj.includes     = ['.']
    obj.name         = 'libltc'
    obj.target       = 'ltc'
    obj.vnum         = LIBLTC_LIB_VERSION
    obj.install_path = os.path.join(bld.env['LIBDIR'], 'ardour3')
    obj.defines     = ['PACKAGE="' + I18N_PACKAGE + '"']

def shutdown():
    autowaf.shutdown()

=== libs/midi++2/wscript ===
#!/usr/bin/env python
from waflib.extras import autowaf as autowaf
from waflib import Options
import os
import sys

# Version of this package (even if built as a child)
MAJOR = '2'
MINOR = '1'
MICRO = '1'
LIBMIDIPP_VERSION = "%s.%s.%s" % (MAJOR, MINOR, MICRO)

# Library version (UNIX style major, minor, micro)
# major increment <=> incompatible changes
# minor increment <=> compatible changes (additions)
# micro increment <=> no interface changes
LIBMIDIPP_LIB_VERSION = '4.1.0'

# Variables for 'waf dist'
APPNAME = 'libmidipp'
VERSION = LIBMIDIPP_VERSION

# Mandatory variables
top = '.'
out = 'build'

path_prefix = 'libs/midi++2/'

libmidi_sources = [
        'midi.cc',
        'channel.cc',
        'ipmidi_port.cc',
        'jack_midi_port.cc',
        'manager.cc',
        'parser.cc',
        'port.cc',
        'midnam_patch.cc',
        'mmc.cc',
        'mtc.cc',
        'version.cc',
]

def options(opt):
    autowaf.set_options(opt)
    opt.add_option('--test', action='store_true', default=False, dest='build_tests',
                    help="Build unit tests")

def configure(conf):
    conf.load('compiler_cxx')
    autowaf.build_version_files(path_prefix+'midi++/version.h', path_prefix+'version.cc',
                    'midipp', MAJOR, MINOR, MICRO)
    autowaf.configure(conf)
    autowaf.check_pkg(conf, 'cppunit', uselib_store='CPPUNIT', atleast_version='1.12.0', mandatory=False)
    autowaf.check_pkg(conf, 'jack', uselib_store='JACK', atleast_version='0.118.2')
    autowaf.check_pkg(conf, 'libxml-2.0', uselib_store='XML')
    autowaf.check_pkg(conf, 'sigc++-2.0', uselib_store='SIGCPP', atleast_version='2.0')

    # Boost headers
    autowaf.check_header(conf, 'cxx', 'boost/shared_ptr.hpp')
    autowaf.check_header(conf, 'cxx', 'boost/weak_ptr.hpp')

def build(bld):
    # Library
    if bld.is_defined ('INTERNAL_SHARED_LIBS'):
        obj              = bld.shlib(features = 'cxx cxxshlib', source=libmidi_sources)
    else:
        obj              = bld.stlib(features = 'cxx cxxstlib', source=libmidi_sources)
        obj.cxxflags = [ '-fPIC', '-DWITH_JACK_MIDI' ]
    # everybody loves JACK
    obj.export_includes = ['.']
    obj.includes     = ['.', '../surfaces/control_protocol']
    obj.name         = 'libmidipp'
    obj.target       = 'midipp'
    obj.uselib       = 'GLIBMM SIGCPP XML JACK OSX'
    obj.use          = 'libpbd libevoral libtimecode'
    obj.vnum         = LIBMIDIPP_LIB_VERSION
    obj.install_path = os.path.join(bld.env['LIBDIR'], 'ardour3')

    if bld.env['BUILD_TESTS'] and bld.is_defined('HAVE_CPPUNIT'): 
        # Unit tests
        obj              = bld(features = 'cxx cxxprogram')
        obj.source       = '''
                test/MidnamTest.cpp
                test/testrunner.cpp
        '''
        obj.includes     = ['.', './src']
        obj.use          = 'libmidipp'
        obj.uselib       = 'CPPUNIT XML'
        obj.target       = 'run-tests'
        obj.name         = 'libmidipp-tests'
        obj.install_path = ''

def shutdown():
    autowaf.shutdown()

=== libs/panners/wscript ===
#!/usr/bin/env python
from waflib.extras import autowaf as autowaf
import os

# Mandatory variables
top = '.'
out = 'build'

panners = [ '2in2out', '1in2out', 'vbap' ]

def options(opt):
    autowaf.set_options(opt)

def sub_config_and_use(conf, name, has_objects = True):
    conf.recurse(name)
    autowaf.set_local_lib(conf, name, has_objects)

def configure(conf):
    autowaf.set_recursive()
    autowaf.configure(conf)

    for i in panners:
        sub_config_and_use(conf, i)

def build(bld):
    for i in panners:
        bld.recurse(i)

=== libs/rubberband/wscript ===
#!/usr/bin/env python
from waflib.extras import autowaf as autowaf
import os
import glob

# Version of this package (even if built as a child)
LIBRUBBERBAND_VERSION = '0.0.0'

# Library version (UNIX style major, minor, micro)
# major increment <=> incompatible changes
# minor increment <=> compatible changes (additions)
# micro increment <=> no interface changes
LIBRUBBERBAND_LIB_VERSION = '4.1.0'

# Variables for 'waf dist'
APPNAME = 'librubberband'
VERSION = LIBRUBBERBAND_VERSION

# Mandatory variables
top = '.'
out = 'build'

def options(opt):
    autowaf.set_options(opt)

def configure(conf):
    conf.load('compiler_cxx')
    autowaf.configure(conf)

def build(bld):
    # Library
    obj = bld(features = 'cxx cxxshlib')
    prefix = 'libs/rubberband/'
    sources = glob.glob(prefix + 'src/*.cpp')
    obj.source = [ ]
    for i in sources:
        obj.source += [ i.replace(prefix, '') ]
    obj.export_includes = ['.']
    obj.includes     = ['.', 'rubberband']
    obj.name         = 'librubberband'
    obj.target       = 'rubberband'
    obj.uselib       = 'FFTW3 FFTW3F SAMPLERATE SNDFILE'
    obj.use          = 'libvamphost'
    obj.vnum         = LIBRUBBERBAND_LIB_VERSION
    obj.install_path = os.path.join(bld.env['LIBDIR'], 'ardour3')
    obj.cxxflags     = '-DPACKAGE="librubberband"'

def shutdown():
    autowaf.shutdown()

=== libs/surfaces/wscript ===
#!/usr/bin/env python
from waflib.extras import autowaf as autowaf
from waflib import Options

# Version of this package (even if built as a child)
LIBSURFACES_VERSION = '4.1.0'

# Library version (UNIX style major, minor, micro)
# major increment <=> incompatible changes
# minor increment <=> compatible changes (additions)
# micro increment <=> no interface changes
LIBSURFACES_LIB_VERSION = '4.1.0'

# Variables for 'waf dist'
APPNAME = 'libsurfaces'
VERSION = LIBSURFACES_VERSION

# Mandatory variables
top = '.'
out = 'build'

children = [
        'control_protocol',
        'frontier',
        'generic_midi',
        'mackie',
        'osc',
        'tranzport',
        'wiimote'
]

def options(opt):
    autowaf.set_options(opt)

def sub_config_and_use(conf, name, has_objects = True):
    conf.recurse(name)
    autowaf.set_local_lib(conf, name, has_objects)

def configure(conf):
    autowaf.set_recursive()
    autowaf.configure(conf)

    for i in children:
        sub_config_and_use(conf, i)

    #autowaf.check_pkg(conf, 'libusb-1.0', uselib_store='USB', mandatory=False)
    #if Options.options.tranzport and conf.is_defined('HAVE_USB'):
    #    conf.define('BUILD_TRANZPORT', 1)

    autowaf.check_pkg (conf, 'liblo', mandatory=False, uselib_store="LO", atleast_version="0.24")

    conf.check_cc (header_name='cwiid.h', define_name='HAVE_CWIID_H',mandatory=False)
    if conf.is_defined('HAVE_CWIID_H'):
        conf.check_cc (header_name='bluetooth/bluetooth.h', define_name='HAVE_BLUETOOTH_H',mandatory=False)
        if conf.is_defined('HAVE_BLUETOOTH_H'):
            autowaf.check_pkg(conf, 'cwiid', uselib_store='CWIID', atleast_version='0.6.00')
            conf.define ('BUILD_WIIMOTE', 1)
        else:
            print('You are missing the libbluetooth headers needed to compile wiimote support')
    else:
            print('You are missing the cwiid headers needed to compile wiimote support')

def build(bld):
    bld.recurse('control_protocol')
    bld.recurse('generic_midi')
    bld.recurse('mackie')
    if bld.is_defined ('HAVE_LO'):
        bld.recurse('osc')
    if bld.is_defined('BUILD_WIIMOTE'):
        bld.recurse('wiimote')
    if bld.is_defined('BUILD_TRANZPORT'):
        bld.recurse('tranzport')

def shutdown():
    autowaf.shutdown()

=== libs/taglib/wscript ===
#!/usr/bin/env python
from waflib.extras import autowaf as autowaf
import glob
import os

# Version of this package (even if built as a child)
LIBTAGLIB_VERSION = '0.0.0'

# Library version (UNIX style major, minor, micro)
# major increment <=> incompatible changes
# minor increment <=> compatible changes (additions)
# micro increment <=> no interface changes
LIBTAGLIB_LIB_VERSION = '0.0.0'

# Variables for 'waf dist'
APPNAME = 'libtaglib'
VERSION = LIBTAGLIB_VERSION

# Mandatory variables
top = '.'
out = 'build'

def options(opt):
    autowaf.set_options(opt)

def configure(conf):
    conf.load('compiler_cxx')
    autowaf.configure(conf)

def build(bld):
    # Library
    obj = bld(features = 'cxx cxxshlib')
    sources = bld.path.ant_glob('taglib/*.cpp')
    sources += bld.path.ant_glob('taglib/flac/*.cpp')
    sources += bld.path.ant_glob('taglib/mpc/*.cpp')
    sources += bld.path.ant_glob('taglib/mpeg/*.cpp')
    sources += bld.path.ant_glob('taglib/mpeg/id3v1/*.cpp')
    sources += bld.path.ant_glob('taglib/mpeg/id3v2/*.cpp')
    sources += bld.path.ant_glob('taglib/mpeg/id3v2/frames/*.cpp')
    sources += bld.path.ant_glob('taglib/ogg/*.cpp')
    sources += bld.path.ant_glob('taglib/ogg/vorbis/*.cpp')
    sources += bld.path.ant_glob('taglib/ogg/speex/*.cpp')
    sources += bld.path.ant_glob('taglib/ogg/flac/*.cpp')
    sources += bld.path.ant_glob('taglib/trueaudio/*.cpp')
    sources += bld.path.ant_glob('taglib/wavpack/*.cpp')
    sources += bld.path.ant_glob('taglib/ape/*.cpp')
    sources += bld.path.ant_glob('taglib/toolkit/*.cpp')
    obj.source = sources

    include_dirs = '''
            taglib
            taglib/toolkit
            taglib/flac
            taglib/ape
            taglib/mpc
            taglib/mpeg
            taglib/mpeg/id3v1
            taglib/mpeg/id3v2
            taglib/wavpack
            taglib/trueaudio
            taglib/ogg
            taglib/ogg/vorbis
            taglib/ogg/speex
            taglib/ogg/flac
    '''.split()
    obj.export_includes = ['.', 'taglib', 'taglib/toolkit']
    obj.includes     = include_dirs
    obj.name         = 'libtaglib'
    obj.target       = 'taglib'
    obj.vnum         = LIBTAGLIB_LIB_VERSION
    obj.install_path = os.path.join(bld.env['LIBDIR'], 'ardour3')

def shutdown():
    autowaf.shutdown()

=== libs/vamp-plugins/wscript ===
#!/usr/bin/env python
from waflib.extras import autowaf as autowaf
import os

# Version of this package (even if built as a child)
LIBARDOURVAMPPLUGINS_VERSION = '0.0.0'

# Library version (UNIX style major, minor, micro)
# major increment <=> incompatible changes
# minor increment <=> compatible changes (additions)
# micro increment <=> no interface changes
LIBARDOURVAMPPLUGINS_LIB_VERSION = '0.0.0'

# Variables for 'waf dist'
APPNAME = 'libardourvampplugins'
VERSION = LIBARDOURVAMPPLUGINS_VERSION

# Mandatory variables
top = '.'
out = 'build'

def options(opt):
    autowaf.set_options(opt)

def configure(conf):
    conf.load('compiler_cxx')
    autowaf.configure(conf)
    autowaf.check_pkg(conf, 'fftw3f', uselib_store='FFTW3F', mandatory=True)
    autowaf.check_pkg(conf, 'aubio', uselib_store='AUBIO', mandatory=False)
    conf.write_config_header('libvampplugins-config.h', remove=False)

def build(bld):
    # Library
    obj = bld(features = 'cxx cxxshlib')
    obj.source = '''
            plugins.cpp
            AmplitudeFollower.cpp
            OnsetDetect.cpp
            PercussionOnsetDetector.cpp
            SpectralCentroid.cpp
            ZeroCrossing.cpp
    '''
    obj.export_includes = ['.']
    obj.includes     = ['.']
    obj.name         = 'libardourvampplugins'
    obj.target       = 'ardourvampplugins'
    obj.uselib       = 'FFTW3F'
    obj.use          = 'libvampplugin libqmdsp'
    if bld.is_defined('HAVE_AUBIO'):
        obj.source += ' Onset.cpp '
        obj.uselib += ' AUBIO '
    obj.vnum         = LIBARDOURVAMPPLUGINS_LIB_VERSION
    obj.install_path = os.path.join(bld.env['LIBDIR'], 'ardour3', 'vamp')

def shutdown():
    autowaf.shutdown()

=== libs/vamp-sdk/wscript ===
#!/usr/bin/env python
from waflib.extras import autowaf as autowaf
import os

# Version of this package (even if built as a child)
LIBVAMP_VERSION = '0.0.0'

# Library version (UNIX style major, minor, micro)
# major increment <=> incompatible changes
# minor increment <=> compatible changes (additions)
# micro increment <=> no interface changes
LIBVAMP_LIB_VERSION = '0.0.0'

# Variables for 'waf dist'
APPNAME = 'libvamp'
VERSION = LIBVAMP_VERSION

# Mandatory variables
top = '.'
out = 'build'

def options(opt):
    autowaf.set_options(opt)

def configure(conf):
    conf.load('compiler_cxx')
    autowaf.configure(conf)
    autowaf.check_pkg(conf, 'fftw3', uselib_store='FFTW3', mandatory=True)
    autowaf.check_pkg(conf, 'fftw3f', uselib_store='FFTW3F', mandatory=True)
    conf.env.append_value('CXXFLAGS', '-DHAVE_FFTW3')

def build(bld):
    # Host Library
    obj = bld(features = 'cxx cxxshlib')
    obj.source = '''
            src/vamp-hostsdk/PluginHostAdapter.cpp
            src/vamp-hostsdk/PluginBufferingAdapter.cpp
            src/vamp-hostsdk/PluginChannelAdapter.cpp
            src/vamp-hostsdk/PluginInputDomainAdapter.cpp
            src/vamp-hostsdk/PluginLoader.cpp
            src/vamp-hostsdk/PluginWrapper.cpp
            src/vamp-hostsdk/RealTime.cpp
    '''
    obj.export_includes = ['.']
    obj.includes     = ['.']
    obj.name         = 'libvamphost'
    obj.target       = 'vamphost'
    obj.uselib       = 'FFTW3 FFTW3F'
    obj.vnum         = LIBVAMP_LIB_VERSION
    obj.install_path = os.path.join(bld.env['LIBDIR'], 'ardour3')

    # Plugin Library
    obj = bld(features = 'cxx cxxshlib')
    obj.source = '''
            src/vamp-sdk/PluginAdapter.cpp
            src/vamp-sdk/RealTime.cpp
    '''
    obj.export_includes = ['.']
    obj.includes     = ['.']
    obj.name         = 'libvampplugin'
    obj.target       = 'vampplugin'
    obj.uselib       = 'FFTW3 FFTW3F'
    obj.vnum         = LIBVAMP_LIB_VERSION
    obj.install_path = os.path.join(bld.env['LIBDIR'], 'ardour3')

def shutdown():
    autowaf.shutdown()

=== debian/changelog ===
ardour3 (3.4~dfsg-3ubuntu1) saucy; urgency=low

  * Cherry-pick from Debian:
    +  Build for i686 instead of i386 to enable SSE

 -- Iain Lane <iain@orangesquash.org.uk>  Sat, 05 Oct 2013 11:49:27 +0100

ardour3 (3.4~dfsg-3) unstable; urgency=low

  [ Felipe Sateler ]
  * Build translations (Closes: #724315)
  * configure: set --dist-target parameter (Closes: #724526)

 -- Adrian Knoth <adi@drcomp.erfurt.thur.de>  Fri, 04 Oct 2013 18:46:35 +0200

ardour3 (3.4~dfsg-2) unstable; urgency=low

  * Team upload.

  [ Felipe Sateler ]
  * Re-upload to unstable

  [ Jaromír Mikeš ]
  * Update copyright file.

 -- Felipe Sateler <fsateler@debian.org>  Sat, 21 Sep 2013 19:05:02 -0300

ardour3 (3.4~dfsg-1) unstable; urgency=low

  * Team upload.
  [ Adrian Knoth ]
  * Initial release. (Closes: #623339 #622634 #717277)
  * Improve debian/copyright
  * Imported Upstream version 3.4~dfsg
    - Drop patches not relevant to ardour3

  [ Jaromír Mikeš ]
  * Create xmp icon fron png one.
  * Fix desktop and menu files.

  [ Felipe Sateler ]
  * Remove obsolete ardour3-{flavour} files, we don't have flavors anymore
  * Remove obsolete series.disabled file

 -- Felipe Sateler <fsateler@debian.org>  Mon, 16 Sep 2013 13:20:44 -0300

=== debian/control ===
Source: ardour3
Section: sound
Priority: optional
Maintainer: Debian Multimedia Maintainers <pkg-multimedia-maintainers@lists.alioth.debian.org>
Uploaders:
 Adrian Knoth <adi@drcomp.erfurt.thur.de>,
 Jaromír Mikeš <mira.mikes@seznam.cz>
Build-Depends:
 autotools-dev,
 cdbs,
 debhelper (>= 9),
 devscripts,
 dh-buildinfo,
 gettext,
 intltool,
 ladspa-sdk (>= 1.1-2),
 libasound2-dev (>= 0.9.4),
 libaubio-dev (>= 0.3.2),
 libboost-dev (>= 1.49.0),
 libcairomm-1.0-dev (>= 1.10.0),
 libcurl4-gnutls-dev (>= 7.25.0),
 libfftw3-dev (>= 3.3.1),
 libgnomecanvas2-dev (>= 2.30.3),
 libgnomecanvasmm-2.6-dev (>= 2.26.0),
 libgtkmm-2.4-dev (>= 2.24.2),
 libjack-dev,
 liblilv-dev,
 liblo-dev (>= 0.26~),
 liblrdf0-dev (>= 0.4.0),
 libpangomm-1.4-dev (>= 2.28.4),
 libpcre3-dev,
 libraptor2-dev (>= 2.0.9),
 librasqal3-dev (>= 0.9.28),
 librdf0-dev (>= 1.0.15),
 libsamplerate0-dev (>= 0.1.8),
 libserd-dev (>= 0.18.2~),
 libsigc++-2.0-dev (>= 2.2.10),
 libsndfile1-dev (>= 1.0.25),
 libsord-dev (>= 0.12.0~),
 libsoundtouch-dev (>= 1.5.0),
 libsratom-dev (>= 0.4.2~),
 libsuil-dev (>= 0.6.10~),
 libusb-dev,
 libxml2-dev (>= 2.5.7),
 lv2-dev (>= 1.2.0),
 python-isodate,
 python-rdflib,
 python-setuptools,
 uuid-dev,
 vamp-plugin-sdk (>=2.1)
Standards-Version: 3.9.4
Homepage: http://www.ardour.org/
Vcs-Git: git://anonscm.debian.org/pkg-multimedia/ardour3.git
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=pkg-multimedia/ardour3.git

Package: ardour3
Architecture: any
Depends:
 ${cdbs:Depends},
 ${misc:Depends},
 ${python:Depends},
 ${shlibs:Depends}
Recommends:
 ${cdbs:Recommends}
Suggests:
 ${shlibs:Suggests}
Conflicts:
 ${cdbs:Conflicts}
Replaces:
 ${cdbs:Replaces}
Description: digital audio workstation (graphical gtk2 interface)
 Ardour is a multichannel hard disk recorder (HDR) and digital audio
 workstation (DAW).  It can be used to control, record, edit and run
 complex audio setups.
 .
 Ardour supports pro-audio interfaces
 through the ALSA project, which provides high quality, well designed
 device drivers and API's for audio I/O under Linux. Any interface
 supported by ALSA can be used with Ardour. This includes the
 all-digital 26 channel RME Hammerfall, the Midiman Delta 1010 and many
 others.
 .
 Ardour has support for 24 bit samples
 using floating point internally, non-linear editing with unlimited undo,
 a user-configurable mixer, MTC master/slave capabilities, MIDI hardware
 control surface compatibility.
 .
 It supports MIDI
 Machine Control, and so can be controlled from any MMC controller and
 many modern digital mixers.
 .
 Ardour contains a
 powerful multitrack audio editor/arranger that is completely
 non-destructive and capable of all standard non-linear editing
 operations (insert, replace, delete, move, trim, select,
 cut/copy/paste). The editor has unlimited undo/redo capabilities and can
 save independent "versions" of a track or an entire piece
 .
 Ardour's editor supports the community-developed LADSPA
 plugin standard.  Arbitrary chains of plugins can be attached to any
 portion of a track.  Every mixer strip can have any number of inputs
 and outputs, not just mono, stereo or 5.1.  An N-way panner is
 included, with support for various panning models.  Pre- and post-fader
 sends exist, each with their own gain and pan controls.  Every mixer
 strip acts as its own bus, and thus the bus count in Ardour is
 unlimited.  You can submix any number of strips into another
 strip.
 .
 Ardour's channel capacity is limited only
 by the number on your audio interface and the ability of your disk
 subsystem to stream the data back and forth.
 .
 JACK
 (the JACK Audio Connection Kit) is used for all audio I/O, permitting
 data to be exchanged in perfect samplesync with other applications
 and/or hardware audio interfaces.
 .
 Ardour is
 sample rate and size neutral - any hardware formats from 8 to 32 bits,
 and rates from 8kHz to 192kHz.  Internal processing in 32/64 bit IEEE
 floating point format.
 .
 Further information can be
 found at <http://ardour.org/>.

=== debian/rules ===
#!/usr/bin/make -f
#
# Robert Jordens <jordens@debian.org>
#
# This software may be used and distributed according to the terms
# of the GNU General Public License, incorporated herein by reference.

-include /usr/share/cdbs/1/rules/upstream-tarball.mk
-include /usr/share/cdbs/1/rules/utils.mk
include /usr/share/cdbs/1/rules/debhelper.mk
include /usr/share/cdbs/1/class/makefile.mk

DEB_CLEAN_EXCLUDE=debian/tmp
DEB_DESTDIR = $(CURDIR)/debian/tmp/

# ignore oddly packaged bzip2 archive to not upset dpkg
DEB_COPYRIGHT_CHECK_IGNORE_REGEX = ^\./waf|\./debian/(changelog|copyright(|_hints|_newhints))$

DIST_TARGET = none
ifneq (,$(findstring i386,$(DEB_BUILD_ARCH)))
	DIST_TARGET = i686
endif
ifneq (,$(findstring amd64,$(DEB_BUILD_ARCH)))
	DIST_TARGET = x86_64
endif

LD_LIBRARY_PATH += :$(DEB_DESTDIR)/usr/lib/ardour3/

waf-configure-options = --lv2 \
	--lxvst \
	--freedesktop \
	--configdir=/etc/ \
	--noconfirm \
	--prefix=/usr/ \
	--no-phone-home \
	--dist-target=$(DIST_TARGET) \
	--optimize \


DEB_MAKE_EXTRA_ARGS = -v --destdir=$(CURDIR)/debian/tmp
DEB_MAKE_BUILD_TARGET = build i18n_mo
DEB_MAKE_ENVVARS = CFLAGS="$(or $(CFLAGS_$(cdbs_curpkg)),$(CFLAGS))" CXXFLAGS="$(or $(CXXFLAGS_$(cdbs_curpkg)),$(CXXFLAGS))" CPPFLAGS="$(or $(CPPFLAGS_$(cdbs_curpkg)),$(CPPFLAGS))" LDFLAGS="$(or $(LDFLAGS_$(cdbs_curpkg)),$(LDFLAGS))"
DEB_MAKE_INVOKE = $(DEB_MAKE_ENVVARS) $(CURDIR)/waf-light $(DEB_MAKE_EXTRA_ARGS)
DEB_MAKE_INSTALL_TARGET = install


clean::
	rm -f autowaf.pyc
	rm -f .lock-wscript .lock-waf_linux2_build
	find waflib -name "*.pyc" -delete || true
	find . -name "*.mo" -delete || true
	rm -rf build
	rm -f \
		gtk2_ardour/version.cc\
		gtk2_ardour/version.h\
		libs/ardour/ardour/version.h\
		libs/ardour/config_text.cc\
		libs/ardour/svn_revision.cc\
		libs/ardour/version.cc\
		libs/gtkmm2ext/gtkmm2ext/version.h\
		libs/gtkmm2ext/version.cc\
		libs/midi++2/midi++/version.h\
		libs/midi++2/version.cc\
		libs/pbd/pbd/version.h\
		libs/pbd/version.cc
	rm -rf debian/tmp


common-configure-arch common-configure-indep:: common-configure-impl
common-configure-impl:: debian/stamp-waf-configure libs/ardour/revision.cc


libs/ardour/revision.cc:
	echo '#include "ardour/revision.h"' > $@
	echo "namespace ARDOUR { const char* revision = \"${DEB_VERSION}\"; }" >> $@

debian/stamp-waf-configure:
	chmod +x ./waf-light
	$(DEB_MAKE_INVOKE) configure $(waf-configure-options)
	touch $@
clean::
	rm -f debian/stamp-waf-configure
	rm -f libs/ardour/revision.cc

# Needed at build time
# (separated in build tools, core, Glib/GTK and audio dependencies)
CDBS_BUILD_DEPENDS += , gettext,\
					  intltoolm,\
					  debhelper (>= 9)
CDBS_BUILD_DEPENDS += , libboost-dev (>= 1.49.0),\
					  libcurl4-gnutls-dev (>= 7.25.0),\
					  libfftw3-dev (>= 3.3.1),\
					  libraptor2-dev (>= 2.0.9),\
					  librdf0-dev (>= 1.0.15),\
					  liblrdf0-dev (>= 0.4.0), \
					  libserd-dev (>= 0.18.2~),\
					  libsord-dev (>= 0.12.0~),\
					  libsuil-dev (>= 0.6.10~),\
					  liblilv-dev,\
					  libsratom-dev (>= 0.4.2~),\
					  libsigc++-2.0-dev (>= 2.2.10),\
					  libusb-dev,\
					  uuid-dev,\
					  libxml2-dev (>= 2.5.7),\
					  librasqal3-dev (>= 0.9.28),\
					  libcwiid-dev
CDBS_BUILD_DEPENDS += , libcairomm-1.0-dev (>= 1.10.0),\
					  libgnomecanvas2-dev (>= 2.30.3),\
					  libgnomecanvasmm-2.6-dev (>= 2.26.0),\
					  libgtkmm-2.4-dev (>= 2.24.2),\
					  libpangomm-1.4-dev (>= 2.28.4)
CDBS_BUILD_DEPENDS += , ladspa-sdk (>= 1.1-2),\
					  libasound2-dev (>= 0.9.4),\
					  libaubio-dev (>= 0.3.2),\
					  libjack-dev,\
					  liblo-dev (>= 0.26~),\
					  libsamplerate0-dev (>= 0.1.8),\
					  libsndfile1-dev (>= 1.0.25),\
					  libsoundtouch-dev (>= 1.5.0),\
					  lv2-dev (>= 1.2.0),\
					  vamp-plugin-sdk (>=2.1)
CDBS_BUILD_DEPENDS += , python-setuptools,\
					  python-isodate,\
					  libpcre3-dev,\
					  python-rdflib


# Needed always/often/sometimes at runtime
CDBS_DEPENDS_ALL = python, python-twisted, python-gtk2, jackd
CDBS_RECOMMENDS_ALL = iceweasel | www-browser
CDBS_SUGGESTS_ALL = jamin, qjackctl

# Ensure only one variant is installed at a time
CDBS_PROVIDES_ardour-altivec = ardour
CDBS_PROVIDES_ardour-i686 = ardour

# Quirk for derivatives using different packaging name
ifeq (Ubuntu,$(shell dpkg-vendor --query Vendor))
CDBS_RECOMMENDS_ALL = firefox | www-browser
endif
